function [cnmty,V]=AEssR3(uC,oC,ud,od,OrietnPoints,transparency,varargin) 
%     [uC,oC] x \subseteq [ud,od]
%   
%    
%   OrientPoints -    ,  
%                  0 -  , 1 - ;
%   transparency -   ,  
%                  0 -  , 1 - .
%  : 
%   cnmty -    : 1 - , 0 - .
%   V -   (orientation points)
%
%    (varargin)
%   W -   (DrawBox),  6   
%                  xb,xe,yb,ye,zb,ze,  
%                  xb,yb,zb -   ,
%                  xe,ye,ze -   .
%
% :    
% :  15/09/2012
%
%  : 
%  uC=[18 -16  -8;  -9 -15 16;  -8 8 -11];
%  oC=[14 -20 -14; -13 -19 12; -12 4 -15];
%  ud=[-7; 10; -1];
%  od=[-7; 10; -1];
%  [V,cnmty]=AEssR3(uC,oC,ud,od,1,0) 
%  [V,cnmty]=AEssR3(uC,oC,ud,od,1,0,,,,) 


   cnmty=true;
   OrientPoints=0;

   % (    -)   
   % [uC,oC] x \subseteq [ud,od]   k  
   %   Ak(:,:)x>=bk    Ak  bk
   Appp(:,:)=[eye(3); uC; -oC ]; 
   Appm(:,:)=[  1 0 0; 0  1 0; 0 0 -1; uC(:,1) uC(:,2) oC(:,3); -oC(:,1) -oC(:,2) -uC(:,3)];
   Apmp(:,:)=[  1 0 0; 0 -1 0; 0 0  1; uC(:,1) oC(:,2) uC(:,3); -oC(:,1) -uC(:,2) -oC(:,3)];
   Ampp(:,:)=[ -1 0 0; 0  1 0; 0 0  1; oC(:,1) uC(:,2) uC(:,3); -uC(:,1) -oC(:,2) -oC(:,3)];
   Apmm(:,:)=[  1 0 0; 0 -1 0; 0 0 -1; uC(:,1) oC(:,2) oC(:,3); -oC(:,1) -uC(:,2) -uC(:,3)];
   Ampm(:,:)=[ -1 0 0; 0  1 0; 0 0 -1; oC(:,1) uC(:,2) oC(:,3); -uC(:,1) -oC(:,2) -uC(:,3)];
   Ammp(:,:)=[ -1 0 0; 0 -1 0; 0 0  1; oC(:,1) oC(:,2) uC(:,3); -uC(:,1) -uC(:,2) -oC(:,3)];
   Ammm(:,:)=[-eye(3); oC; -uC ];
   bppp=[ 0; 0; 0; ud; -od ];
   bppm=bppp;
   bpmp=bppp;
   bmpp=bppp;
   bpmm=bppp;
   bmpm=bppp;
   bmmp=bppp;
   bmmm=bppp;

   %       - 
   % (      ) 
   %     
   V=zeros(0,3);
   cfinite=1; % ,     (.. )

   %       , 
   %     Ak
   [Appp,bppp,cnmtyppp]=ClearZeroRows(Appp,bppp);
   mppp=size(bppp,1);
   [Appm,bppm,cnmtyppm]=ClearZeroRows(Appm,bppm);
   mppm=size(bppp,1);
   [Apmp,bpmp,cnmtypmp]=ClearZeroRows(Apmp,bpmp);
   mpmp=size(bpmp,1);
   [Ampp,bmpp,cnmtympp]=ClearZeroRows(Ampp,bmpp);
   mmpp=size(bmpp,1);
   [Apmm,bpmm,cnmtypmm]=ClearZeroRows(Apmm,bpmm);
   mpmm=size(bpmm,1);
   [Ampm,bmpm,cnmtympm]=ClearZeroRows(Ampm,bmpm);
   mmpm=size(bmpm,1);
   [Ammp,bmmp,cnmtymmp]=ClearZeroRows(Ammp,bmmp);
   mmmp=size(bmmp,1);
   [Ammm,bmmm,cnmtymmm]=ClearZeroRows(Ammm,bmmm);
   mmmm=size(bmmm,1);

   %      ,   
   %       -,
   %        ,
   %    cfinite=0
   [V,cfinite]=addV(V,cfinite,Appp,bppp,mppp,cnmtyppp);
   [V,cfinite]=addV(V,cfinite,Appm,bppm,mppm,cnmtyppm);
   [V,cfinite]=addV(V,cfinite,Apmp,bpmp,mpmp,cnmtypmp);
   [V,cfinite]=addV(V,cfinite,Ampp,bmpp,mmpp,cnmtympp);
   [V,cfinite]=addV(V,cfinite,Apmm,bpmm,mpmm,cnmtypmm);
   [V,cfinite]=addV(V,cfinite,Ampm,bmpm,mmpm,cnmtympm);
   [V,cfinite]=addV(V,cfinite,Ammp,bmmp,mmmp,cnmtymmp);
   [V,cfinite]=addV(V,cfinite,Ammm,bmmm,mmmm,cnmtymmm);

   if size(V,1)==0
      disp(' - ');
      cnmty=false;
      return;
   end


   %   
   var=(length(varargin)==6) %    , var==1
   if var %    ,     
      W=[varargin{1} varargin{3} varargin{5}; varargin{2} varargin{4} varargin{6}]
   else % 
      %       (= ) 
      [W]=PicWindow3AE(V);
      %    ,    W 
      if ~cfinite
         radius=(W(2,:)-W(1,:))/2;
         W=W+2*[-radius; radius];
      end
   end

   %         
   %          Ak(:,:)x>=bk 
   if ~cfinite | var
      Appp=[Appp; eye(3); -eye(3) ];
      bppp=[bppp; W(1,:)';-W(2,:)'];
      Appm=[Appm; eye(3); -eye(3) ];
      bppm=[bppm; W(1,:)';-W(2,:)'];
      Apmp=[Apmp; eye(3); -eye(3) ];
      bpmp=[bpmp; W(1,:)';-W(2,:)'];
      Ampp=[Ampp; eye(3); -eye(3) ];
      bmpp=[bmpp; W(1,:)';-W(2,:)'];
      Apmm=[Apmm; eye(3); -eye(3) ];
      bpmm=[bpmm; W(1,:)';-W(2,:)'];
      Ampm=[Ampm; eye(3); -eye(3) ];
      bmpm=[bmpm; W(1,:)';-W(2,:)'];
      Ammp=[Ammp; eye(3); -eye(3) ];
      bmmp=[bmmp; W(1,:)';-W(2,:)'];
      Ammm=[Ammm; eye(3); -eye(3) ];
      bmmm=[bmmm; W(1,:)';-W(2,:)'];
   end


   %    
   %      - ,
   %    - ,     - 
%    figure   %      
   figure(1) %     
   clf(1);   %      
   hold on
   axis vis3d; % auto, on, normal, fill, image, tight, equal
   axis([W(1,1),W(2,1),W(1,2),W(2,2),W(1,3),W(2,3)]);
   view(3);
   grid on;
   xlabel('x1');
   ylabel('x2');
   zlabel('x3');

   V = NonRepeatRows(V);
   if OrietnPoints
      scatter3(V(:,1),V(:,2),V(:,3),15,'k','filled');
   end

   DrawHedrons(Appp,bppp,mppp,transparency,var);
   DrawHedrons(Appm,bppm,mppm,transparency,var);
   DrawHedrons(Apmp,bpmp,mpmp,transparency,var);
   DrawHedrons(Ampp,bmpp,mmpp,transparency,var);
   DrawHedrons(Apmm,bpmm,mpmm,transparency,var);
   DrawHedrons(Ampm,bmpm,mmpm,transparency,var);
   DrawHedrons(Ammp,bmmp,mmmp,transparency,var);
   DrawHedrons(Ammm,bmmm,mmmm,transparency,var);


%   camlight left %   
%   hidden on %    -    'FaceAlpha',1
   hold off

end                
