function [A,b,cnmty] = ClearZeroRows(A,b)
%       A   
%   $Ax\geq b, A\in \mbR^{m\times n}, b\in\mbR^m$.
%    -    - 
%   +  cnmty =    % control not empty
%   (true - , false - , .   ).
%
%     cnmty = true  ,  
%        size(A,1)=0, 
%        = R^n    . 

    [m,n] = size(A);
    cnmty = true;
    p = [];

    for i=1:m
%       if single(A(i,:)) == zeros(1,n)
        if max(abs(A(i,:)))<1.e-8
            p = [p i];
%           if 0 < b(i)
            if b(i)>1e-12
                cnmty = false;
            end
        end
    end
    
    A(p,:) = [];
    b(p,:) = [];
                
end                
