function []=DrawHedrons(A,b,m,transparency,var)
    %    i     
    %   A(i,:)x=b(i)) (" i")

    mn=size(b,1);

%    for i=1:mn
    for i=4:mn  %         
  
        [xi,At,bt,y1,y2]=ChangeVariable(A,b,i);
    
        %     At (   ,  i) 
        [At,bt,cnmtyt]=ClearZeroRows(At,bt);
      
        if ~cnmtyt
           continue; %  i    H
        end

        %    At(k,:)y=bt(k)   H   (y)
        %  St        
        % [ beginy1 beginy2 endy1 endy2 k ]
        [St]=BoundaryIntervals(At,bt);

        %   St   Pt  i- 
        if size(St,1)>0
           [Pt] = Intervals2Path(St);

           %   Pt   (x)
           %%%%%P=xi+y1*Pt(:,1)+y2*Pt(:,2);
           P=zeros(0,3);
           for k=1:size(Pt,1)
               P=[P ; xi+y1*Pt(k,1)+y2*Pt(k,2) ];
           end

           %         0.7, 
           %     -       0.4
           transp=1;
           c='g';
           if transparency
              transp= 0.7; 
           end
           if i>m
              if var
                 c='y';
              else
                 c='r';
              end
              transp=0.4; 
           end

           %  " i"
           fill3(P(:,1),P(:,2),P(:,3),c,'FaceAlpha',transp);
%           fill3(P(:,1),P(:,2),P(:,3),c,'EdgeColor','k','FaceAlpha',transp); %  
%           fill3(P(:,1),P(:,2),P(:,3),c,'FaceAlpha',1); %  

        end

     end    

end